/*
 * hello.go --
 *
 *      A go hello world program, which uses a goroutine and a
 *      channel to block the main function. Build an executable
 *      using 'go build hello.go'.
 */
 
package main

import "fmt"

func worker(input chan string, done chan<- bool) {
        for msg := range input {
                fmt.Print(msg)
        }
        fmt.Println()
        done <- true
}

func main() {
        msgs := [...] string {"hello", " ", "world"}
        pipe := make(chan string)
        done := make(chan bool)
        go worker(pipe, done)
        for _, msg := range msgs {
                pipe <- msg
        }
        close(pipe)
        <- done
}
